VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8436
   ClientLeft      =   48
   ClientTop       =   432
   ClientWidth     =   7980
   LinkTopic       =   "Form1"
   ScaleHeight     =   8436
   ScaleWidth      =   7980
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List2 
      Height          =   3312
      Left            =   2280
      TabIndex        =   9
      Top             =   4800
      Width           =   5172
   End
   Begin VB.CommandButton Command7 
      Caption         =   "All Registered Services"
      Height          =   492
      Left            =   5880
      TabIndex        =   8
      Top             =   240
      Width           =   1692
   End
   Begin VB.CommandButton Command6 
      Caption         =   "Active Services"
      Height          =   492
      Left            =   3960
      TabIndex        =   7
      Top             =   240
      Width           =   1572
   End
   Begin VB.TextBox Text1 
      Height          =   492
      Left            =   120
      TabIndex        =   6
      Text            =   "Eventlog"
      Top             =   2760
      Width           =   1812
   End
   Begin VB.ListBox List1 
      Height          =   2736
      Left            =   2280
      TabIndex        =   5
      Top             =   1800
      Width           =   5172
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Command5"
      Height          =   492
      Left            =   360
      TabIndex        =   4
      Top             =   1680
      Width           =   1332
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Status"
      Height          =   492
      Left            =   2160
      TabIndex        =   3
      Top             =   840
      Width           =   972
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Pause"
      Height          =   492
      Left            =   480
      TabIndex        =   2
      Top             =   840
      Width           =   972
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Start"
      Height          =   492
      Left            =   2160
      TabIndex        =   1
      Top             =   240
      Width           =   972
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Stop"
      Height          =   492
      Left            =   480
      TabIndex        =   0
      Top             =   240
      Width           =   972
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Usage: the first parameter is the remote computer name, if it is "" the computer is the local computer, the second is the service name.
Private Sub Command1_Click()
    ServiceStop "", "Schedule"
End Sub

Private Sub Command2_Click()
    ServiceStart "", "Schedule"
End Sub

Private Sub Command3_Click()
    ServicePause "", "Schedule"
End Sub

Private Sub Command4_Click()
    MsgBox ServiceStatus("", "Schedule")
End Sub

Private Sub Command5_Click()

      Dim hSCM  As Long
      Dim hSVC As Long
      Dim pSTATUS As SERVICE_STATUS
      Dim udtConfig As QUERY_SERVICE_CONFIG
      Dim lRet As Long
      Dim lBytesNeeded As Long
      Dim sTemp As String
      Dim pFileName As Long

   List1.Clear

      ' Open The Service Control Manager
      '
      hSCM = OpenSCManager(vbNullString, vbNullString, SC_MANAGER_CONNECT)
      If hSCM = 0 Then
         MsgBox "Error - " & Err.LastDllError
      End If

      ' Open the specific Service to obtain a handle
      '
      hSVC = OpenService(hSCM, Trim(Text1.Text), GENERIC_READ)
         If hSVC = 0 Then
            MsgBox "Error - " & Err.LastDllError
            GoTo CloseHandles
         End If

      ' Fill the Service Status Structure
      '
      lRet = QueryServiceStatus(hSVC, pSTATUS)
      If lRet = 0 Then
         MsgBox "Error - " & Err.LastDllError
         GoTo CloseHandles
      End If

      ' Report the Current State
      '
      Select Case pSTATUS.dwCurrentState
      Case SERVICE_STOPPED
         sTemp = "The Service is Stopped"
      Case SERVICE_START_PENDING
         sTemp = "The Service Being Started"
      Case SERVICE_STOP_PENDING
         sTemp = "The Service is in the process of being stopped"
      Case SERVICE_RUNNING
         sTemp = "The Service is Running"
      Case SERVICE_CONTINUE_PENDING
         sTemp = "The Service is in the process of being Continued"
      Case SERVICE_PAUSE_PENDING
         sTemp = "The Service is in the process of being Paused"
      Case SERVICE_PAUSED
         sTemp = "The Service is Paused"
      Case SERVICE_ACCEPT_STOP
         sTemp = "The Service is Stopped"
      Case SERVICE_ACCEPT_PAUSE_CONTINUE
         sTemp = "The Service is "
      Case SERVICE_ACCEPT_SHUTDOWN
         sTemp = "The Service is being Shutdown"
      End Select

      List1.AddItem "Service Status : " & sTemp

      ' Call QueryServiceConfig with 1 byte buffer to generate an error
      ' that returns the size of a buffer we need.
      '
      ReDim abConfig(0) As Byte
      lRet = QueryServiceConfig(hSVC, abConfig(0), 0&, lBytesNeeded)
      If lRet = 0 And Err.LastDllError <> ERROR_INSUFFICIENT_BUFFER Then
         MsgBox "Error - " & Err.LastDllError
      End If

      ' Redim our byte array to the size necessary and call
      ' QueryServiceConfig again
      '
      ReDim abConfig(lBytesNeeded) As Byte
      lRet = QueryServiceConfig(hSVC, abConfig(0), lBytesNeeded, _
         lBytesNeeded)
      If lRet = 0 Then
         MsgBox "Error - " & Err.LastDllError
         GoTo CloseHandles
      End If

      ' Fill our Service Config User Defined Type.
      '
      CopyMemory udtConfig, abConfig(0), Len(udtConfig)

      List1.AddItem "Service Type: " & udtConfig.dwServiceType
      List1.AddItem "Service Start Type: " & udtConfig.dwStartType
      List1.AddItem "Service Error Control: " & udtConfig.dwErrorControl

      sTemp = Space(255)

      ' Now use the pointer obtained to copy the path into the temporary
      ' String Variable
      '
      lRet = lstrcpy(sTemp, udtConfig.lpBinaryPathName)
      List1.AddItem "Service Binary Path: " & sTemp

      lRet = lstrcpy(sTemp, udtConfig.lpDependencies)
      List1.AddItem "Service Dependencies: " & sTemp

      lRet = lstrcpy(sTemp, udtConfig.lpDisplayName)
      List1.AddItem "Service DisplayName: " & sTemp

      lRet = lstrcpy(sTemp, udtConfig.lpLoadOrderGroup)
      List1.AddItem "Service LoadOrderGroup: " & sTemp

      lRet = lstrcpy(sTemp, udtConfig.lpServiceStartName)
      List1.AddItem "Service Start Name: " & sTemp

CloseHandles:
   ' Close the Handle to the Service
   '
      CloseServiceHandle (hSVC)

   ' Close the Handle to the Service Control Manager
   '
      CloseServiceHandle (hSCM)

End Sub

Private Sub Command6_Click()
    'Getting only the active services
    GetServiceInfo SERVICE_ACTIVE
   End Sub

Private Sub Command7_Click()
    'Getting all services registered
    GetServiceInfo SERVICE_ACTIVE Or SERVICE_INACTIVE
End Sub
